Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weblogic.apache.xerces.dom
Class ParentNode

    java.lang.Object
      |
      +--weblogic.apache.xerces.dom.NodeImpl
            |
            +--weblogic.apache.xerces.dom.ChildNode
                  |
                  +--weblogic.apache.xerces.dom.ParentNode

Direct Known Subclasses:
  CoreDocumentImpl, DocumentFragmentImpl, DocumentTypeImpl, ElementDefinitionImpl, ElementImpl, EntityImpl, EntityReferenceImpl

public abstract class ParentNode
extends ChildNode

ParentNode inherits from ChildNode and adds the capability of having child nodes. Not every node in the DOM can have children, so only nodes that can should inherit from this class and pay the price for it.

ParentNode, just like NodeImpl, also implements NodeList, so it can return itself in response to the getChildNodes() query. This eliminiates the need for a separate ChildNodeList object. Note that this is an IMPLEMENTATION DETAIL; applications should _never_ assume that this identity exists. On the other hand, subclasses may need to override this, in case of conflicting names. This is the case for the classes HTMLSelectElementImpl and HTMLFormElementImpl of the HTML DOM.

While we have a direct reference to the first child, the last child is stored as the previous sibling of the first child. First child nodes are marked as being so, and getNextSibling hides this fact.

Note: Not all parent nodes actually need to also be a child. At some point we used to have ParentNode inheriting from NodeImpl and another class called ChildAndParentNode that inherited from ChildNode. But due to the lack of multiple inheritance a lot of code had to be duplicated which led to a maintenance nightmare. At the same time only a few nodes (Document, DocumentFragment, Entity, and Attribute) cannot be a child so the gain in memory wasn't really worth it. The only type for which this would be the case is Attribute, but we deal with there in another special way, so this is not applicable.

This class doesn't directly support mutation events, however, it notifies the document when mutations are performed so that the document class do so.

WARNING: Some of the code here is partially duplicated in AttrImpl, be careful to keep these two classes in sync!

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Author:
  Arnaud Le Hors, IBM, Joe Kesselman, IBM, Andy Clark, IBM
See Also:
  Serialized Form

Field Summary
`protected ChildNode` | `fCachedChild` Last requested node.
`protected int` | `fCachedChildIndex` Last requested node index.
`protected int` | `fCachedLength` Cached node list length.
`protected ChildNode` | `firstChild` First child.
`protected CoreDocumentImpl` | `ownerDocument` Owner document.

Fields inherited from class weblogic.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class weblogic.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, IGNORABLEWS, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, UNNORMALIZED`

Constructor Summary
`` | `ParentNode()` Constructor for serialization.
`protected` | `ParentNode(CoreDocumentImpl ownerDocument)` No public constructor; only subclasses of ParentNode should be instantiated, and those normally via a Document's factory methods

Method Summary
`org.w3c.dom.Node` | `cloneNode(boolean deep)` Returns a duplicate of a given node.
`org.w3c.dom.NodeList` | `getChildNodes()` Obtain a NodeList enumerating all children of this node.
`protected org.w3c.dom.NodeList` | `getChildNodesUnoptimized()` Create a NodeList to access children that is use by subclass elements that have methods named getLength() or item(int).
`org.w3c.dom.Node` | `getFirstChild()` The first child of this Node, or null if none.
`org.w3c.dom.Node` | `getLastChild()` The last child of this Node, or null if none.
`int` | `getLength()` NodeList method: Count the immediate children of this node
`org.w3c.dom.Document` | `getOwnerDocument()` Find the Document that this Node belongs to (the document in whose context the Node was created).
`boolean` | `hasChildNodes()` Test whether this node has any children.
`org.w3c.dom.Node` | `insertBefore(org.w3c.dom.Node newChild, org.w3c.dom.Node refChild)` Move one or more node(s) to our list of children.
`org.w3c.dom.Node` | `item(int index)` NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.
`void` | `normalize()` Override default behavior to call normalize() on this Node's children.
`org.w3c.dom.Node` | `removeChild(org.w3c.dom.Node oldChild)` Remove a child from this Node.
`org.w3c.dom.Node` | `replaceChild(org.w3c.dom.Node newChild, org.w3c.dom.Node oldChild)` Make newChild occupy the location that oldChild used to have.
`void` | `setReadOnly(boolean readOnly, boolean deep)` Override default behavior so that if deep is true, children are also toggled.
`protected void` | `synchronizeChildren()` Override this method in subclass to hook in efficient internal data structure.

Methods inherited from class weblogic.apache.xerces.dom.ChildNode
`getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class weblogic.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getAttributes, getLocalName, getNamespaceURI, getNodeName, getNodeType, getNodeValue, getPrefix, getReadOnly, getUserData, hasAttributes, isSupported, removeEventListener, setNodeValue, setPrefix, setUserData, synchronizeData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### ownerDocument

    protected CoreDocumentImpl ownerDocument

  Owner document.

### firstChild

    protected ChildNode firstChild

  First child.

### fCachedLength

    protected transient int fCachedLength

  Cached node list length.

### fCachedChild

    protected transient ChildNode fCachedChild

  Last requested node.

### fCachedChildIndex

    protected transient int fCachedChildIndex

  Last requested node index.

Constructor Detail

### ParentNode

    protected ParentNode(CoreDocumentImpl ownerDocument)

  No public constructor; only subclasses of ParentNode should be instantiated, and those normally via a Document's factory methods

### ParentNode

    public ParentNode()

  Constructor for serialization.

Method Detail

### cloneNode

    public org.w3c.dom.Node cloneNode(boolean deep)

  Returns a duplicate of a given node. You can consider this a generic "copy constructor" for nodes. The newly returned object should be completely independent of the source object's subtree, so changes in one after the clone has been made will not affect the other.

  Example: Cloning a Text node will copy both the node and the text it contains.

  Example: Cloning something that has children -- Element or Attr, for example -- will _not_ clone those children unless a "deep clone" has been requested. A shallow clone of an Attr node will yield an empty Attr of the same name.

  NOTE: Clones will always be read/write, even if the node being cloned is read-only, to permit applications using only the DOM API to obtain editable copies of locked portions of the tree.

  Overrides:
    cloneNode in class ChildNode

### getOwnerDocument

    public org.w3c.dom.Document getOwnerDocument()

  Find the Document that this Node belongs to (the document in whose context the Node was created). The Node may or may not currently be part of that Document's actual contents.

  Overrides:
    getOwnerDocument in class NodeImpl

### hasChildNodes

    public boolean hasChildNodes()

  Test whether this node has any children. Convenience shorthand for (Node.getFirstChild()!=null)

  Overrides:
    hasChildNodes in class NodeImpl

### getChildNodes

    public org.w3c.dom.NodeList getChildNodes()

  Obtain a NodeList enumerating all children of this node. If there are none, an (initially) empty NodeList is returned.

  NodeLists are "live"; as children are added/removed the NodeList will immediately reflect those changes. Also, the NodeList refers to the actual nodes, so changes to those nodes made via the DOM tree will be reflected in the NodeList and vice versa.

  In this implementation, Nodes implement the NodeList interface and provide their own getChildNodes() support. Other DOMs may solve this differently.

  Overrides:
    getChildNodes in class NodeImpl

### getFirstChild

    public org.w3c.dom.Node getFirstChild()

  The first child of this Node, or null if none.

  Overrides:
    getFirstChild in class NodeImpl

### getLastChild

    public org.w3c.dom.Node getLastChild()

  The last child of this Node, or null if none.

  Overrides:
    getLastChild in class NodeImpl

### insertBefore

    public org.w3c.dom.Node insertBefore(org.w3c.dom.Node newChild,
                                         org.w3c.dom.Node refChild)
                                  throws org.w3c.dom.DOMException

  Move one or more node(s) to our list of children. Note that this implicitly removes them from their previous parent.

  Parameters:
    `newChild` - The Node to be moved to our subtree. As a convenience feature, inserting a DocumentNode will instead insert all its children.
    `refChild` - Current child which newChild should be placed immediately before. If refChild is null, the insertion occurs after all existing Nodes, like appendChild().
  Throws:
    DOMException(HIERARCHY_REQUEST_ERR) - if newChild is of a type that shouldn't be a child of this node, or if newChild is an ancestor of this node.
    DOMException(WRONG_DOCUMENT_ERR) - if newChild has a different owner document than we do.
    DOMException(NOT_FOUND_ERR) - if refChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    insertBefore in class NodeImpl

### removeChild

    public org.w3c.dom.Node removeChild(org.w3c.dom.Node oldChild)
                                 throws org.w3c.dom.DOMException

  Remove a child from this Node. The removed child's subtree remains intact so it may be re-inserted elsewhere.

  Returns:
    oldChild, in its new state (removed).
  Throws:
    DOMException(NOT_FOUND_ERR) - if oldChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    removeChild in class NodeImpl

### replaceChild

    public org.w3c.dom.Node replaceChild(org.w3c.dom.Node newChild,
                                         org.w3c.dom.Node oldChild)
                                  throws org.w3c.dom.DOMException

  Make newChild occupy the location that oldChild used to have. Note that newChild will first be removed from its previous parent, if any. Equivalent to inserting newChild before oldChild, then removing oldChild.

  Throws:
    DOMException(HIERARCHY_REQUEST_ERR) - if newChild is of a type that shouldn't be a child of this node, or if newChild is one of our ancestors.
    DOMException(WRONG_DOCUMENT_ERR) - if newChild has a different owner document than we do.
    DOMException(NOT_FOUND_ERR) - if oldChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    replaceChild in class NodeImpl

### getLength

    public int getLength()

  NodeList method: Count the immediate children of this node

  Returns:
    int
  Overrides:
    getLength in class NodeImpl

### item

    public org.w3c.dom.Node item(int index)

  NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.

  Parameters:
    `index` - int
  Returns:
    org.w3c.dom.Node
  Overrides:
    item in class NodeImpl

### getChildNodesUnoptimized

    protected final org.w3c.dom.NodeList getChildNodesUnoptimized()

  Create a NodeList to access children that is use by subclass elements that have methods named getLength() or item(int). ChildAndParentNode optimizes getChildNodes() by implementing NodeList itself. However if a subclass Element implements methods with the same name as the NodeList methods, they will override the actually methods in this class.

  To use this method, the subclass should implement getChildNodes() and have it call this method. The resulting NodeList instance maybe shared and cached in a transient field, but the cached value must be cleared if the node is cloned.

### normalize

    public void normalize()

  Override default behavior to call normalize() on this Node's children. It is up to implementors or Node to override normalize() to take action.

  Overrides:
    normalize in class NodeImpl

### setReadOnly

    public void setReadOnly(boolean readOnly,
                            boolean deep)

  Override default behavior so that if deep is true, children are also toggled.

  Overrides:
    setReadOnly in class NodeImpl
  See Also:

    Note: this will not change the state of an EntityReference or its children, which are always read-only.

### synchronizeChildren

    protected void synchronizeChildren()

  Override this method in subclass to hook in efficient internal data structure.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs70
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved.
WebLogic Server 7.0 API Reference